<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $page;
 
$piwecard = get_plugin_data($plugin_id);

if (isset($_POST['submit'])) {
	$errors = array();
	$configuration = array();

	$configuration['validity'] = $_POST['ecard_validity_list'];
	$configuration['validity'] = explode(',', $configuration['validity']);
	
    $configuration['validity_default'] = isset($_POST['ecard_validity_default']) ? $_POST['ecard_validity_default'] : null;
	
	if ($configuration['validity'][0] == null) {
		$errors['validity'] = array(
									'style_error_text' => 'display: block;',
									'style_error_input'	=> 'class="ecard_error_input"',
		);
	} elseif (!in_array($configuration['validity_default'], $configuration['validity'])) {
		$configuration['validity_default'] = $configuration['validity'];
	}
	$conf_validity = array();
	foreach ($configuration['validity'] as $validity) {
		array_push($conf_validity, intval($validity));
	}
	$configuration['validity'] = array_unique($conf_validity, SORT_NUMERIC);
	asort($configuration['validity']);
	
	$configuration['validity_choice'] = ((isset($_POST['ecard_validity_choice']) && $_POST['ecard_validity_choice'] == '1') ? true : false);
    $configuration['sender_copy'] = ((isset($_POST['ecard_sender_copy']) && $_POST['ecard_sender_copy'] == '1') ? true : false);
	$configuration['image_size'] = $_POST['ecard_image_size'];
    
	$configuration['image_border']['display'] = ((isset($_POST['ecard_image_border']) && $_POST['ecard_image_border'] == '1') ? true : false);
	$configuration['image_border']['style'] = $_POST['ecard_image_border_style'];
	$configuration['image_border']['width'] = ((isset($_POST['ecard_image_border_width']) && $_POST['ecard_image_border_width'] != '1') ? $_POST['ecard_image_border_width'] : $piwecard->get_default_config_param('ecard_image_border_width'));
	$configuration['image_border']['color'] = ((isset($_POST['ecard_image_border_color']) && $_POST['ecard_image_border_color'] != '1') ? $_POST['ecard_image_border_color'] : $piwecard->get_default_config_param('ecard_image_border_color'));
	
	$configuration['sender_email_change'] = ((isset($_POST['ecard_sender_email_change']) && $_POST['ecard_sender_email_change'] == '1') ? true : false);
	
	$ecard_email_format_array = array();
	foreach($_POST['ecard_email_format'] as $ecard_email_format) {
		array_push($ecard_email_format_array, $ecard_email_format);
	}
	$configuration['email_format_authorized'] = $ecard_email_format_array;
	$configuration['email_format_default'] = $_POST['ecard_email_format_default'];
	if (!in_array($configuration['email_format_default'], $configuration['email_format_authorized']))
		$errors['email_format_default'] = array(
												'style_error_text' => 'display: block;',
		);
    $configuration['show_image_infos'] = ((isset($_POST['ecard_show_image_infos']) && $_POST['ecard_show_image_infos'] == '1') ? true : false);
    $configuration['default_guest_email'] = $_POST['ecard_default_guest_email'];
	if ($configuration['default_guest_email'] != '' && !$piwecard->is_valid_email($configuration['default_guest_email']))
		$errors['default_guest_email'] = array(
												'style_error_text' 	=> 'display: block;',
												'style_error_input'	=> 'class="ecard_error_input"',
		);
	$configuration['email_subject'] = htmlspecialchars($_POST['ecard_email_subject']);
	if ($configuration['email_subject'] == '')
		$errors['email_subject'] = array(
												'style_error_text' 	=> 'display: block;',
												'style_error_input'	=> 'class="ecard_error_input"',
		);
	$configuration['email_message']['text'] = htmlspecialchars($_POST['ecard_email_message_text']);
	if ($configuration['email_message']['text'] == '')
		$errors['email_message']['text'] = array(
												'style_error_text' 	=> 'display: block;',
												'style_error_input'	=> 'class="ecard_error_input"',
		);
	$configuration['email_message']['html'] = stripslashes($_POST['ecard_email_message_html']);
	if ($configuration['email_message']['html'] == '')
		$errors['email_message']['html'] = array(
												'style_error_text' 	=> 'display: block;',
												'style_error_input'	=> 'class="ecard_error_input"',
		);
	
	foreach ($configuration as $key => $item) {
		if (!array_key_exists($key, $errors)) {
			$piwecard->config[$key] = $configuration[$key];
		}
	}
	$piwecard->set_config();
	
	if (empty($errors)) {
		array_push($page['infos'], l10n('Information data registered in database'));
	} else {
		$template->assign('ecard_errors', $errors);
		array_push($page['errors'], l10n('piwecard_errors'));
	}
}

if (isset($_POST['reset'])) {
	$piwecard->config['email_subject'] = $piwecard->get_default_config_param('email_subject');
	$email_message = $piwecard->get_default_config_param('email_message');
	$piwecard->config['email_message']['text'] = $email_message['text'];
	$piwecard->config['email_message']['html'] = $email_message['html'];
	
	$piwecard->set_config();
	
	array_push($page['infos'], l10n('Information data registered in database'));
}

if (isset($errors['validity'])) {
	$piwecard->config['validity'] = null;
	$configuration['validity'] = null;
}
$template->assign('ecard_validity_list',((isset($configuration['validity'])) ? $configuration['validity'] : $piwecard->config['validity']));

if (isset($piwecard->config['validity'])) {
	foreach($piwecard->config['validity'] as $validity) {
		$template->append('ecard_validity', array(
												'id' => $validity,
												'name' => ($validity == 0) ? l10n('piwecard_nolimit') : $validity.' '.l10n('piwecard_days'),
												'selected' => (($piwecard->config['validity_default'] == $validity) ? 'selected' : ''),
											)
		);
	}
}
$template->assign('ecard_validity_choice', $piwecard->config['validity_choice'] ? 'checked="checked"' : '');

$derivative_map = array();
foreach(ImageStdParams::get_defined_type_map() as $params) {
	$derivative_map[$params->type]['name'] = l10n($params->type);
	if ($params->type == $piwecard->config['image_size'])
		$derivative_map[$params->type]['selected'] = 'checked="checked"';
	else
		$derivative_map[$params->type]['selected'] = '';
}
$template->assign('generate_derivatives_types', $derivative_map);

$template->assign('ecard_image_border', (($piwecard->config['image_border']['display']) ? 'checked="checked"' : ''));
$template->assign('ecard_image_border_style', array(
													'solid' => (($piwecard->config['image_border']['style'] == 'solid') ? 'checked="checked"' : ''),
													'dashed' => (($piwecard->config['image_border']['style'] == 'dashed') ? 'checked="checked"' : ''),
													'dotted' => (($piwecard->config['image_border']['style'] == 'dotted') ? 'checked="checked"' : ''),
													'double' => (($piwecard->config['image_border']['style'] == 'double') ? 'checked="checked"' : ''),
												)
);
$template->assign('ecard_image_border_width', $piwecard->config['image_border']['width']);
$template->assign('ecard_image_border_color', $piwecard->config['image_border']['color']);

$template->assign('ecard_sender_copy', $piwecard->config['sender_copy'] ? 'checked="checked"' : '');
$template->assign('ecard_sender_email_change', $piwecard->config['sender_email_change'] ? 'checked="checked"' : '');
$email_format_array = array();
foreach($piwecard->config['email_format'] as $email_format) {
	array_push($email_format_array, array(
											'id' => $email_format,
											'selected' => (in_array($email_format, $piwecard->config['email_format_authorized']) ? 'checked="checked"' : ''),
											'selected_default' => (($piwecard->config['email_format_default'] == $email_format) ? 'checked="checked"' : ''),
											'language_string' => 'piwecard_email_format_'.$email_format,
										)
	);
}
$template->assign('ecard_email_format', $email_format_array);
$template->assign('ecard_email_format_default', $email_format_array);
$template->assign('ecard_show_image_infos', $piwecard->config['show_image_infos'] ? 'checked="checked"' : '');
$template->assign('ecard_default_guest_email', ((isset($configuration['default_guest_email'])) ? $configuration['default_guest_email'] : $piwecard->config['default_guest_email']));
$template->assign('ecard_email_subject', ((isset($configuration['email_subject'])) ? $configuration['email_subject'] : htmlspecialchars_decode($piwecard->config['email_subject'])));
$template->assign('ecard_email_message_text', ((isset($configuration['email_message']['text'])) ? $configuration['email_message']['text'] : htmlspecialchars_decode($piwecard->config['email_message']['text'])));
$template->assign('ecard_email_message_html', ((isset($configuration['email_message']['html'])) ? $configuration['email_message']['html'] : htmlspecialchars_decode($piwecard->config['email_message']['html'])));
$template->assign('preview_image', get_root_url().PIWECARD_PATH.'admin/images/image.jpg');
    
$template->set_filename('plugin_admin_content', dirname(__FILE__) . '/template/admin_configuration.tpl');
$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
?>